package com.example.springdemo.controller;

import com.example.springdemo.entities.Users;
import com.example.springdemo.service.UsersService;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;

import java.util.Optional;

@RestController
@RequestMapping("/users")
public class UsersController {

    @Resource
    private UsersService usersService;

    @PostMapping("/add")
    public Users addUsers(@RequestBody Users users) {
        return usersService.addUsers(users);
    }

    @DeleteMapping("/delete/{id}")
    public void deleteUsers(@PathVariable("id") Long id) {
        usersService.deleteUsersById(id);
    }

    @PutMapping("/update")
    public Users updateUsers(@RequestBody Users users) {
        return usersService.updateUsers(users);
    }

    @GetMapping("/find")
    public Iterable<Users> getUsers() {
        return usersService.findAllUsers();
    }

    @GetMapping("/find/{name}")
    public Users getUsersByName(@PathVariable("name") String name) {
        return usersService.findByName(name);
    }

    @GetMapping("/find/{id}")
    public Optional<Users> getUsersById(@PathVariable("id") Long id) {
        return usersService.findById(id);
    }

}
